<?php
/*------------------------------------------------------------------------
# mod_sp_tweet - Twitter Module by JoomShaper.com
# ------------------------------------------------------------------------
# author    JoomShaper http://www.joomshaper.com
# copyright Copyright (C) 2010 JoomShaper.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.joomshaper.com - http://www.joomxpert.com
-------------------------------------------------------------------------*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modSPTweetHelper
{	
	var $config;
	var $raw_data;
	
	//Initiate configurations
	function init(&$params) {
		$this->config = array(
            'username' 	=> $params->get('username','joomshaper'),
            'tweets' 	=> $params->get('tweets',4),
            'linked_search' 	=> $params->get('linked_search',1),
            'linked_mention' 	=> $params->get('linked_mention',1),
			'target' => $params->get('target','_blank'),		
			'error' => ''		
		);
	}

	//Curl function
	function curl_init() {
		if (function_exists('curl_init'))
		{
			// initializing connection
			$curl = curl_init();
			// saves us before putting directly results of request
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
			// url to get
			//
			curl_setopt($curl, CURLOPT_URL,'http://twitter.com/statuses/user_timeline/' . $this->config['username'] . '.xml?count=' . $this->config['tweets']);
			// timeout in seconds
			curl_setopt($curl, CURLOPT_TIMEOUT, 20);
			// useragent
			curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
			// reading location
			$this->raw_data = curl_exec($curl);
			// closing connection
			curl_close($curl);
		}
		else
		{
			echo 'cURL extension is not available on your server';
		}
	}
	
	function tweets() {
		$xml = JFactory::getXMLParser('Simple');
		
		if ($xml->loadString($this->raw_data)) {
			if(!isset($xml->document->error[0]))
			{		
				$status = $xml->document->status;
				$i=0;
				$lists= array();
				for ($i=0;$i<count($status);$i++) {
					$datas= $xml->document->status[$i];
					//Tweet time
					$lists[$i]->created_at =  JText::_('ABOUT') . '&nbsp;' . modSPTweetHelper::timeago($datas->created_at[0]->_data) . '&nbsp;' . JText::_('AGO');
					//Tweet id
					$lists[$i]->id =  $datas->id[0]->_data;
					//Profile image
					$lists[$i]->image =  $datas->user[0]->profile_image_url[0]->_data;
					//User id
					$lists[$i]->userid =  $datas->user[0]->id[0]->_data;
					//Display name
					$lists[$i]->name =  $datas->user[0]->name[0]->_data;
					//Twitter id
					$lists[$i]->screen_name =  $datas->user[0]->screen_name[0]->_data;
					//Tweet
					$lists[$i]->text =  modSPTweetHelper::prepareTweet($datas->text[0]->_data);	
					//Tweet from					
					$lists[$i]->source =  $datas->source[0]->_data;
				}
				$i++;
			} else {
				//Return error
				echo 'Oops, Twitter id not found!';		
			}	
			
		}
		return $lists;
	}
	
	function prepareTweet($tweet) {
		
		$string=$tweet;
		//Url
		$pattern = '/((ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?)/i';
		$replacement = '<a target="' . $this->config['target'] . '" class="tweet_url" href="$1">$1</a>';
		$string = preg_replace($pattern, $replacement, $string);

		//Search
		if ($this->config['linked_search']==1) {
			$pattern = '/[\#]+([A-Za-z0-9-_]+)/i';
			$replacement = '<a target="' . $this->config['target'] . '" class="tweet_search" href="http://search.twitter.com/search?q=$1">#$1</a>';
			$string = preg_replace($pattern, $replacement, $string);
		}
		
		//Mention
		if ($this->config['linked_mention']==1) {
			$pattern = '/[\@]+([A-Za-z0-9-_]+)/i';
			$replacement = '<a target="' . $this->config['target'] . '" class="tweet_mention" href="http://twitter.com/$1">@$1</a>';
			$string = preg_replace($pattern, $replacement, $string);	
		}
		return $string;
	}
	
	//Function for converting time
	function timeago($timestamp) {
		$time_arr 		= explode(" ",$timestamp);
		$year 			= $time_arr[5];
		$day 			= $time_arr[2];
		$time 			= $time_arr[3];
		$time_array 	= explode(":",$time);
		$month_name 	= $time_arr[1];
		$month = array (
			'Jan' => 1,
			'Feb' => 2,
			'Mar' => 3,
			'Apr' => 4,
			'May' => 5,
			'Jun' => 6,
			'Jul' => 7,
			'Aug' => 8,
			'Sep' => 9,
			'Oct' => 10,
			'Nov' => 11,
			'Dec' => 12
		);
	
		$delta = gmmktime(0, 0, 0, 0, 0) - mktime(0, 0, 0, 0, 0);
		
		$timestamp = mktime($time_array[0], $time_array[1], $time_array[2], $month[$month_name], $day, $year);
	
		$etime = time() - ($timestamp + $delta);
		
		if ($etime < 1) {
			return '0 seconds';
		}
		
		$a = array( 12 * 30 * 24 * 60 * 60  =>  'YEAR',
					30 * 24 * 60 * 60       =>  'MONTH',
					24 * 60 * 60            =>  'DAY',
					60 * 60                 =>  'HOUR',
					60                      =>  'MINUTE',
					1                       =>  'SECOND'
					);
		
		foreach ($a as $secs => $str) {
			$d = $etime / $secs;
			if ($d >= 1) {
				$r = round($d);
				return $r . ' ' . JText::_($str . ($r > 1 ? 'S' : ''));
			}
		}
	}
	
}
 